
WASTE
;----------------
	clrwdt
;----------------

;	  |---	
;CLK = ---|
	
;--------------------------------------
;RESET required ?

;	btfss	NOT_RESET	
;	call	CARD_RESET	;Yes
;--------------------------------------

;Read/Write?

	btfsc	NOT_R_W
	goto	WRITE_BIT	;Yes, write to itself

;Send BIT...
	
	movlw	UFSA		;Units Field Start Address
	subwf	BFP, W
	btfsc	STATUS, C	;BFP<60? (UFSA) (C=0)
	goto	SEND_UNITSF	;No, Send Units Field...

;IDs, serial# ...DESCRIBE BITS....
	
	movf	BFP, W		;set bit address for decode:
	call	GET_BIT_ADDR	;get reg. (byte) address[ACC2] with bit PTR[BPOS]
	
	movf	ACC2, W
	call	CARD_DSR ;get describe bit

;get bit on position 0
	call	GET_BIT

;SEND BIT ON PORT
;this instr. block used for no noise on bus...

	btfsc	ACC1, 0		;1st (0) bit = 1?
	bsf	DATA_OUT	;Yes, set log1
	btfss	ACC1, 0		;1st (0) bit = 0?
	bcf	DATA_OUT

;bit ready on DATA_OUT

	goto	SCAN_CLK_LO
;---------------------------- MEMORY SKIPPED BY BIT SEND --------------------	
;send emulated units field

SEND_UNITSF
	movlw	UFSA		;Units Field Start Address
	subwf	BFP, W		;shift: BFP-60

	call	GET_BIT_ADDR	;get byte address[ACC2] with bit ptr [BPOS]

	call	GET_UFB		;get units field byte
	
	call	GET_BIT		;bit ready in ACC1...
	
;this instr. block used for no noise on bus...

	btfsc	ACC1, 0
	bsf	DATA_OUT	;bit = 1 -> "used unit"
	btfss	ACC1, 0
	bcf	DATA_OUT	;bit = 0 -> not used unit

;used/not used units transmittion done...

	goto	SCAN_CLK_LO

;---------------------------- MEMORY SKIPPED BY SEND_UNITS_(F)IELD --------------------

;"write" to emulated EPROM
WRITE_BIT
	btfss	CHECK_Vpp	;Vpp checking enabled?
	goto	NO_Vpp_SCAN	;skip next instr.

	btfss	Vpp		;Vpp at 1?
	goto	SCAN_CLK_LO	;No, exit

NO_Vpp_SCAN
	movlw	UFSA		;unit Field Start Address
	subwf	BFP, W		;BFP<60?
	btfss	STATUS, C
	goto	SCAN_CLK_LO	;Yes, Not valid status, not enabled (rewrite ID?, descriptor?)

;Modify Decribe bits

MODIFY_DSR
	movlw	UFSA		;address shift...(DSR not required..)
	subwf	BFP, W
	
	call	GET_BIT_ADDR	;address in ACC1

	call	GET_UFB		;get unit field byte

	call	GET_BIT

;!!! you musn't effect C !!!	

	bsf	ACC1, 0		;modify bit

;!!! you musn't effect C !!!

	call	SET_BIT
	
	call	SET_UFB		;bit modified (@BFP[bit] =1)


;shift bit to right position...(n x rlf)

;op done...

;------------------------------------------------------------------------------	
	
;WAIT for CLK=0

;----------------
	clrwdt
;----------------

SCAN_CLK_LO
	btfsc	CLK		;CLK=0?
	goto	SCAN_CLK_LO

;----------------
	clrwdt
;----------------

;-RESET active?

	btfsc	NOT_RESET	;-RESET =0?
	incf	BFP, same	;No, point to next bit
	goto	MAIN_LOOP


